from datetime	import datetime
import sys
import os
import re

IS_INITIALIZED = False

class say:

	def __init__ (self,
		label	= ''		,
		verbose	= 0			,
		dryrun	= False		,
		timetag	= ''		,
		prefix	= '    '	,
	):

		global LABEL
		global VERBOSE
		global DRYRUN
		global TIMETAG
		global PREFIX
		global IS_INITIALIZED

		if IS_INITIALIZED:

			self.set_label	(LABEL   if label   == '    '	else label	)
			self.set_verbose(VERBOSE if verbose ==      0	else verbose)
			self.set_dryrun	(DRYRUN  if not dryrun			else dryrun	)
			self.set_timetag(TIMETAG if timetag ==     ''	else timetag)
			self.set_prefix	(PREFIX  if prefix  == '    '	else prefix )

		else:

			self.set_label	(label  )
			self.set_verbose(verbose)
			self.set_dryrun	(dryrun )
			self.set_timetag(timetag)
			self.set_prefix	(prefix )

			LABEL	= self.LABEL
			VERBOSE	= self.VERBOSE
			DRYRUN	= self.DRYRUN
			TIMETAG	= self.TIMETAG
			PREFIX	= self.PREFIX

			IS_INITIALIZED = True

	def set_label  (self,label  =''		): self.LABEL	= label
	def set_verbose(self,verbose=1		): self.VERBOSE = verbose
	def set_debug  (self,verbose=2		): self.VERBOSE	= verbose
	def set_dryrun (self,dryrun = True	): self.DRYRUN	= dryrun
	def set_timetag(self,timetag= ''  	): self.TIMETAG	= timetag
	def set_prefix (self,prefix	= ''  	): self.PREFIX	= prefix

	def message(self, message='', threshold=0, seiw=''):

		# Only if the VERBOSE level is higher than the
		# threshold, something is actually printed

		if self.VERBOSE >= threshold:
			if self.LABEL:
				if seiw != '':
					seiw = '-'+seiw
				date = ''
				if self.TIMETAG != '':
					date = datetime.now().strftime(self.TIMETAG)
				message_prefix = ['','DRYRUN '][self.DRYRUN]+date+'%'+self.LABEL+seiw+'- '
			else:		# If label is not defined, then just echo
				message_prefix = self.PREFIX

			sys.stderr.write(message_prefix+message+'\n')

	def message_bare(self,message,threshold):
		save = self.LABEL
		self.LABEL = ''
		self.message(message,threshold)
		self.LABEL = save

	def warn(self,message,seiw='W'):			# Always echo to stderr
		self.message(message, self.VERBOSE, seiw)

	def warn_bare(self,message):				# Always echo to stderr
		self.message_bare(message, self.VERBOSE)

	def die(self,message='die',seiw='E',code=1):# Always echo to stderr; then quit with error code 1
		self.message(message, self.VERBOSE, seiw)
		sys.exit(code)

	def done(self,message='done',seiw='S'):		# Always echo to STDERR; then quit with error code 0
		self.message(message, self.VERBOSE, seiw)
		sys.exit(0)

	def yell(self,message,seiw='I'):			# Always echo to stderr
		self.message(message, self.VERBOSE, seiw)

	def yell_bare(self,message):				# Always echo to stderr
		self.message_bare(message, self.VERBOSE)

	def say(self,message,seiw='I'):				# Echo for every non-zero VERBOSE to stderr
		self.message(message, 1, seiw)

	def say_bare(self,message):					# Echo for every non-zero VERBOSE to stderr
		self.message_bare(message, 1)

	def debug(self,message,seiw='I'):			# Echo for every non-zero VERBOSE to stderr
		self.message(message, 2, seiw)

	def debug_bare(self,message):				# Echo for every non-zero VERBOSE to stderr
		self.message_bare(message, 2)

	def deep_debug(self,message,seiw='I'):			# Echo for every non-zero VERBOSE to stderr
		self.message(message, 3, seiw)

	def deep_debug_bare(self,message):				# Echo for every non-zero VERBOSE to stderr
		self.message_bare(message, 3)

	def __repr__(self):
		return "say = isay(label='%s',verbose=%s,dryrun=%s,prefix='%s',timetag='%s')"%(self.LABEL,self.VERBOSE,self.DRYRUN,self.PREFIX,self.TIMETAG)

	def __str__(self):
		return "    label   : '%s'\n    verbose : %s\n    dry run : %s\n    time tag: '%s'\n    prefix  : '%s'"%	\
			(self.LABEL  if self.LABEL  else '(none)',
			 self.VERBOSE,
			 self.DRYRUN,
			 self.TIMETAG if self.TIMETAG else '(none)',
			 self.PREFIX)
'''
#+
# NAME:
#	nice_number
# INPUTS:
#	nr		number, usually an integer
# OPTIONAL INPUTS:
#	prefix		'dec' for decimal prefix (k,M,etc.)
#				'bin' for binary prefix (ki,Mi, etc.)
#	postfix		string appended to prefix; default: null string
#	digits		number of decimal digits in result; default: 1
#	space		string inserted between number and prefix; default: null string
#	fraction	default: 1
# OUTPUTS:
#	result	number in proper format
# PROCEDURE:
#	
'''

def nice_number( nr, prefix='', units='', digits=1, space='', fraction=1, align=False ):

	if isinstance(nr,str):
		result = nr.strip()
		format = '%%.%ds%s'%(digits,space)
		result = format%result

	elif len(prefix) >= 1 and prefix[0] == 'd':
		format = '%%.%df%s%%s'%(digits,space)
		fr = float(nr)
		absnr = abs(nr)

		# 1000   k kilo
		# 1000^2 M mega
		# 1000^3 G giga
		# 1000^4 T tera
		# 1000^5 P peta
		# 1000^6 E exa
		# 1000^7 Z zetta
		# 1000^8 Y yotta
	
		result = format%(fr/1000**8,'Y'	) if absnr >= fraction*1000**8 else \
				 format%(fr/1000**7,'Z'	) if absnr >= fraction*1000**7 else \
				 format%(fr/1000**6,'E'	) if absnr >= fraction*1000**6 else \
				 format%(fr/1000**5,'P'	) if absnr >= fraction*1000**5 else \
				 format%(fr/1000**4,'T'	) if absnr >= fraction*1000**4 else \
				 format%(fr/1000**3,'G'	) if absnr >= fraction*1000**3 else \
				 format%(fr/1000**2,'M'	) if absnr >= fraction*1000**2 else \
				 format%(fr/1000   ,'k'	) if absnr >= fraction*1000    else \
				 format%(nr,' '			) if align else \
				 format%(nr,'' 			)

	elif len(prefix) >= 1 and prefix[0] == 'b':
		format = '%%.%df%s%%s'%(digits,space)
		fr = float(nr)
		absnr = abs(nr)

		# 1024   Ki kibi
		# 1024^2 Mi mebi
		# 1024^3 Gi gibi
		# 1024^4 Ti tebi
		# 1024^5 Pi pebi
		# 1024^6 Ei exbi
		# 1024^7 Zi zebi
		# 1024^8 Yi yobi

		result = format%(fr/1024**8,'Yi') if absnr >= fraction*1024**8 else \
				 format%(fr/1024**7,'Zi') if absnr >= fraction*1024**7 else \
				 format%(fr/1024**6,'Ei') if absnr >= fraction*1024**6 else \
				 format%(fr/1024**5,'Pi') if absnr >= fraction*1024**5 else \
				 format%(fr/1024**4,'Ti') if absnr >= fraction*1024**4 else \
				 format%(fr/1024**3,'Gi') if absnr >= fraction*1024**3 else \
				 format%(fr/1024**2,'Mi') if absnr >= fraction*1024**2 else \
				 format%(fr/1024   ,'ki') if absnr >= fraction*1024    else \
				 format%(nr,'  '		) if align else \
				 format%(nr,''			)

	else:
		result = '%s%s'%(nr,space)

	return result+units

#def nice_wsize( size, digits=1, base=2, in_bytes=False, fraction=1 ):
#	return nice_size( size, digits, base, ' ', in_bytes, fraction )

def nice_size( size, digits=1, base=2, space='', in_bytes=False, fraction=1 ):

	if isinstance(size,str):
		format = '%%.%ds%s'%(digits,space)
		size = format%size

	elif in_bytes:
		size = '%s'%size

	elif base == 10:
		format = '%%.%df%s%%s'%(digits,space)

		if size >= fraction*10**12:
			size = format%(float(size)/10*12,'TB')
		elif size >= fraction*10**9:
			size = format%(float(size)/10**9,'GB')
		elif size >= fraction*10**6:
			size = format%(float(size)/10**6,'MB')
		elif size >= fraction*10**3:
			size = format%(float(size)/10**3,'kB')
		else:
			size = format%(size,'B')

	else:	# base 2
		format = '%%.%df%s%%s'%(digits,space)

		if size >= fraction*2**40:
			size = format%(float(size)/2**40,'TiB')
		elif size >= fraction*2**30:
			size = format%(float(size)/2**30,'GiB')
		elif size >= fraction*2**20:
			size = format%(float(size)/2**20,'MiB')
		elif size >= fraction*2**10:
			size = format%(float(size)/2**10,'kiB')
		else:
			size = format%(size,'B')

	# ternary statement not supported prior to v3.5
	#size =  '%s'%size		   if not human_form	else	\
	#	'%.2f TiB'%(float(size)/TB) if size > TB	else	\
	#	'%.2f GiB'%(float(size)/GB) if size > GB	else	\
	#	'%.2f MiB'%(float(size)/MB) if size > MB	else	\
	#	'%.2f kiB'%(float(size)/kB) if size > kB	else	\
	#	'%s'%size

	return size.strip()

def hide_env( spec, check=False ):

	# Setting check=True forces a check for the existence of the directory
	# but can cause problems for NFS mounts that are not on line:
	# os.path.isdir will freeze the process until there is a timeout.

	match_name  = ''
	match_value = ''

	for name, value in list(os.environ.items()):
		n = len(value)
		if n != 0:
			if not check or os.path.isdir(value):
				if spec.find(value) == 0:
					if n > len(match_value):
						match_name  = name
						match_value = value

	return spec if match_name == '' else '$'+match_name+spec[len(match_value):]

def which( program ):

	return (os.popen('which '+program+' 2> /dev/null').read().split('\n'))[0]

def run_cmd( cmd ):

	say_inst = say( whoami() )
	say_inst.debug( cmd )
	log = cmd if say_inst.DRYRUN else (os.popen(cmd)).read()
	if not say_inst.DRYRUN: say_inst.debug( log )

	return log

def whoami():
	return sys._getframe(1).f_code.co_name

def count_instances( name ):

	say_inst = say( '%s.%s'%('count_instances',whoami()) )

	#name = (os.path.split(argv[0]))[1]+' '+argv[1]
	say_inst.say( 'checking process: %s'%name )

	proc = run_cmd( 'ps -efw | grep "'+name+'"' )
	proc = proc.split('\n')

	cnt = 0
	for p in proc:
		#if p.find('python') != -1 and p.find(name) != -1:
		#if p.find(name) != -1:
		#if p.find(name) != -1 and p.find('grep') == -1:
		if name in p and not 'grep' in p:
			cnt += 1
			say_inst.say( p )

	say_inst.debug( '%d'%cnt,'instance(s) running: %s'%name )

	return cnt

def has_time( tre=None ):
	return True if tre != None and re.search('\(\?P<(?:YYYY|posix)>',tre) else False;
